/* SPDX-License-Identifier: GPL-2.0
 *
 * Copyright (c) 2022-2025 Qualcomm Innovation Center, Inc. All rights reserved.
 */

#ifndef __LINUX_SND_SOC_USB_H
#define __LINUX_SND_SOC_USB_H

#include <sound/soc.h>

enum snd_soc_usb_kctl {
	SND_SOC_USB_KCTL_CARD_ROUTE,
	SND_SOC_USB_KCTL_PCM_ROUTE,
};


struct snd_soc_usb_device {
	int card_idx;
	int chip_idx;

	
	unsigned int *cpcm_idx; 
	unsigned int *ppcm_idx;
	int num_capture; 
	int num_playback;

	struct list_head list;
};


struct snd_soc_usb {
	struct list_head list;
	struct snd_soc_component *component;
	int (*connection_status_cb)(struct snd_soc_usb *usb,
				    struct snd_soc_usb_device *sdev,
				    bool connected);
	int (*update_offload_route_info)(struct snd_soc_component *component,
					 int card, int pcm, int direction,
					 enum snd_soc_usb_kctl path,
					 long *route);
	void *priv_data;
};

#if IS_ENABLED(CONFIG_SND_SOC_USB)
int snd_soc_usb_find_supported_format(int card_idx,
				      struct snd_pcm_hw_params *params,
				      int direction);

int snd_soc_usb_connect(struct device *usbdev, struct snd_soc_usb_device *sdev);
int snd_soc_usb_disconnect(struct device *usbdev, struct snd_soc_usb_device *sdev);
void *snd_soc_usb_find_priv_data(struct device *usbdev);

int snd_soc_usb_setup_offload_jack(struct snd_soc_component *component,
				   struct snd_soc_jack *jack);
int snd_soc_usb_update_offload_route(struct device *dev, int card, int pcm,
				     int direction, enum snd_soc_usb_kctl path,
				     long *route);

struct snd_soc_usb *snd_soc_usb_allocate_port(struct snd_soc_component *component,
					      void *data);
void snd_soc_usb_free_port(struct snd_soc_usb *usb);
void snd_soc_usb_add_port(struct snd_soc_usb *usb);
void snd_soc_usb_remove_port(struct snd_soc_usb *usb);
#else
static inline int
snd_soc_usb_find_supported_format(int card_idx, struct snd_pcm_hw_params *params,
				  int direction)
{
	return -EINVAL;
}

static inline int snd_soc_usb_connect(struct device *usbdev,
				      struct snd_soc_usb_device *sdev)
{
	return -ENODEV;
}

static inline int snd_soc_usb_disconnect(struct device *usbdev,
					 struct snd_soc_usb_device *sdev)
{
	return -EINVAL;
}

static inline void *snd_soc_usb_find_priv_data(struct device *usbdev)
{
	return NULL;
}

static inline int snd_soc_usb_setup_offload_jack(struct snd_soc_component *component,
						 struct snd_soc_jack *jack)
{
	return 0;
}

static int snd_soc_usb_update_offload_route(struct device *dev, int card, int pcm,
					    int direction, enum snd_soc_usb_kctl path,
					    long *route)
{
	return -ENODEV;
}

static inline struct snd_soc_usb *
snd_soc_usb_allocate_port(struct snd_soc_component *component, void *data)
{
	return ERR_PTR(-ENOMEM);
}

static inline void snd_soc_usb_free_port(struct snd_soc_usb *usb)
{ }

static inline void snd_soc_usb_add_port(struct snd_soc_usb *usb)
{ }

static inline void snd_soc_usb_remove_port(struct snd_soc_usb *usb)
{ }
#endif 
#endif 
